<?php
// helpdesk_data.php - PHProjekt Version 4.1
// copyright    2000-2003 Albrecht Guenther  ag@phprojekt.com
// www.phprojekt.com
// Author: Albrecht Guenther

// check whether the lib has been included - authentication!
if (!defined("lib_included")) { die("Please use index.php!"); }

// check role
if (check_role("helpdesk") < 2) { die("You are not allowed to do this!"); }

use_mail('1');

// fetch permission routine
include_once("$lib_path/permission.inc.php");

// set timeproj
if ($step == "worktime") {
  $datum = date("Y-m-d");
  if ($timeproj_ID) { 
    $result = db_query("update ".DB_PREFIX."timeproj 
                           set users='$user_ID',
                               datum='$datum',
                               h=$h,
                               m=$m,
                               note='$note' 
                         where ID = '$timeproj_ID'") or db_die(); 
  }
  else { 
    $result = db_query("insert into ".DB_PREFIX."timeproj 
                               ( ID,         users,   projekt,    datum,   h,   m,   note)  
                        values ($dbIDnull,'$user_ID','$proj_ID','$datum','$h','$m','$note')") or db_die(); 
  }
}

// create subproject
if ($step == "subproject") {
  $datum = date("Y-m-d");
  $end = "2005-12-31";
  // assume that the curent user will be a participant in this project :-)
  $pers[0] = $user_kurz;
  $personen2 = serialize($pers);
  $result = db_query("insert into ".DB_PREFIX."projekte 
                             (   ID,          name,   ende,  personen,wichtung,anfang,    gruppe,       chef,       parent,   note,contact,stundensatz,budget, depend_mode, depend_proj, next_mode, next_proj) 
                      values ($dbIDnull,'$projname','$end','$personen2',0,    '$datum','$user_group','$user_kurz','$parent','$note',   0,       0,        0,         0,           0,          0,       0     )") or db_die();
  // fetch ID and update rts record
  $result = db_query("select ID 
                        from ".DB_PREFIX."projekte 
                       where name = '$projname' and 
                             anfang = '$datum'") or db_die();
  $row = db_fetch_row($result);
  $result = db_query("update ".DB_PREFIX."rts 
                         set proj = '$row[0]' 
                       where ID = '$ID'") or db_die();
}

// move request
if ($step == "moveto") {
  $result = db_query("select ID, name, note, remark 
                        from ".DB_PREFIX."rts 
                       where ID = '$ID'") or db_die();
  $row = db_fetch_row($result);
  $result2 = db_query("select ID, name, note, remark 
                         from ".DB_PREFIX."rts 
                        where ID = '$moveto'") or db_die();
  $row2 = db_fetch_row($result2);
  $name = quote_runtime($row2[1]."\n+ Nr. $row[0]:\n ".$row[1]);
  $note = quote_runtime($row2[2]."\n+ Nr. $row[0]:\n ".$row[2]);
  $remark = quote_runtime($row2[3]."\n+ Nr. $row[0]:\n ".$row[3]);
  $result = db_query("update ".DB_PREFIX."rts 
                         set remark = '$remark', 
                             note='$note', 
                             name = '$name' 
                       where ID = '$moveto'") or db_die();
  $result = db_query("update ".DB_PREFIX."rts 
                         set remark = 'moved to $moveto', 
                             status = '3' 
                       where ID = '$ID'") or db_die();
}

// various actions, all coming from the big form
if ($step == "update") {

  // insert remark
  if ($add_remark) {
    $result = db_query("update ".DB_PREFIX."rts 
                           set remark = '$remark', 
                               solution = '$solution' 
                         where ID = '$ID'") or db_die();
  }

  // solve request, mail to customer, set access
  elseif ($solve) {
    $datetime = date("Y")."-".date("m")."-".date("d")." ".(date("H")+$timezone).":".date("I").":".date("s");
    $result = db_query("update ".DB_PREFIX."rts 
                           set remark = '$remark', 
                               solution = '$solution', 
                               solved = '$user_ID', 
                               status = '4', 
                               solve_time = '$datetime', 
                               acc='$acc' 
                         where ID = '$ID'") or db_die();

    // fetch original question
    $result = db_query("select name, note 
                          from ".DB_PREFIX."rts 
                         where ID = '$ID'") or db_die();
    $row = db_fetch_row($result);

    // body of the mail consists of: "has been answered by NN, question: xyz, answer: xyz ...
    $body = "$rts_58 $user_firstname $user_name\n $rts_0: $row[0]\n $row[1]\n $rts_26: $solution";
    // fetch mail adress
    $result = db_query("select contact, email 
                          from ".DB_PREFIX."rts 
                         where ID = '$ID'") or db_die();
    $row = db_fetch_row($result);
    if ($rts_cust_acc and $adressen) {
      $result2 = db_query("select email 
                             from ".DB_PREFIX."contacts 
                            where ID = '$row[0]'") or db_die();
      $row2 = db_fetch_row($result2);
      $cust_mail = $row2[0];
    }
    else {
      $cust_mail = $row[1];
    }
    // mail to the customer with the solution
    $success = $mail->go($cust_mail, "$rts_59 $ID", $body, $user_email);
    // confirmation screen for the author
    echo "$rts_60.<br><br>\n";
  }

  // stall request
  elseif ($stall) {
    $result = db_query("update ".DB_PREFIX."rts 
                           set status = '2' 
                         where ID = '$ID'") or db_die();
  }

  // update of status, priority etc.
  elseif ($update) {                                           
    // fetch short name of assigned person and compare it to the current one
    $result = db_query("select assigned 
                          from ".DB_PREFIX."rts 
                         where ID = '$ID'") or db_die();
    $row = db_fetch_row($result);                            
    // former user exists and not the same one? -> notify the former user that a change in the assignment takes place
    if ($row[0] <> "" and $row[0] <> $assign) {
      // fetch email from previous assigned and mail notification
      $result2 = db_query("select ".DB_PREFIX."users.email 
                             from ".DB_PREFIX."users,".DB_PREFIX."rts 
                            where ".DB_PREFIX."users.kurz = ".DB_PREFIX."rts.assigned and 
                                  ".DB_PREFIX."rts.ID = '$ID'") or db_die();
      $row2 = db_fetch_row($result2);
      // notify him about the change
      if ($row2[0]) { $success = $mail->go($row2[0], "$rts_0 Nr. $ID", "$user_name $rts50 nr. $ID: $row[0] -> $row2[0]", $rts_mail); }

      //fetch mail from actual assigned and mail mail notification
      $result3 = db_query("select email 
                             from ".DB_PREFIX."users 
                            where kurz = '$assigned'") or db_die();
      $row3 = db_fetch_row($result2);
      if ($row3[0]) { $success = $mail->go($row3[0], "$rts_0 Nr. $ID", "$user_name $rts50 nr. $ID: $row[0] -> $row2[0]", $rts_mail); }
    }
    // update record in db
    $result = db_query("update ".DB_PREFIX."rts 
                           set assigned='$assign', 
                               acc='$acc', 
                               priority='$priority', 
                               remark='$remark' 
                         where ID = '$ID'") or db_die();
  }

  // delete a request
  elseif ($delete) {
    // check persmission
    if (!ereg("c", $user_access)) { die("you're not privileged to do this!"); }

    // delete request
    $result = db_query("delete from ".DB_PREFIX."rts 
                         where ID = '$ID'") or db_die();
  }
} // end of the case $step = update

// show the rts list :-)
include_once("./helpdesk_view.php");

?>
</body>
</html>
