<?php

// branches.inc.php - PHProjekt Version 4.1
// copyright    2000-2003 Albrecht Guenther  ag@phprojekt.com
// www.phprojekt.com
// Author: Albrecht Guenther

$project_fields = array('name','ende','personen','wichtung','status','statuseintrag','anfang','gruppe','chef','typ',
                        'parent','ziel','note','kategorie','contact','stundensatz','budget','div1','div2');

function copy_branch($ID, $new_parent_rootID) {
  // first check whether the target isn't a subrecord of the source
  check_subrecord($ID,$new_parent_rootID);  
  // first copy the root record
  $new_ID = copy_record($ID,$new_parent_rootID);
  // now fetch all childs and walk thorugh the whole branch
  fetch_childs($ID, $new_ID);
}

function fetch_childs($old_parent_ID, $new_parent_ID) { 
  $result = db_query("select ID
                        from ".DB_PREFIX."projekte 
                       where parent = '$old_parent_ID'") or db_die();  
  while ($row = db_fetch_row($result)) {
    $old_ID = $row[0];
    $new_ID = copy_record($row[0], $new_parent_ID);        
    fetch_childs($old_ID, $new_ID); 
  } 
}

function copy_record($ID, $parent_ID) {     
  global $project_fields, $dbIDnull;
  
  $result = db_query("select ".implode(',',$project_fields)."
                        from ".DB_PREFIX."projekte 
                       where ID = '$ID'") or db_die();  
  $row = db_fetch_row($result);
  // and insert this as a new record
  $fields = implode(',',$project_fields);
  $result = db_query("insert into ".DB_PREFIX."projekte 
                             (ID,".$fields.")
                      values ($dbIDnull,'".implode("','",$row)."')") or db_die(); 
  // fetch the ID of this new record      
  $result = db_query("select max(ID)
                        from ".DB_PREFIX."projekte") or db_die();  
  $row = db_fetch_row($result);    
  // don't forget to assign the new record to the current parent!
  $result = db_query("update ".DB_PREFIX."projekte 
                         set parent = $parent_ID
                       where ID = $row[0]") or db_die();
  return $row[0];                                              
}

function check_subrecord($ID, $new_parent_rootID) {
    
  $proj_err_mes = "Sorry but the target record is a subrecord of the source! This would lead to a vanishing project branch. Please try it again";
  // check whether the current record is the target

  if ($ID == $new_parent_rootID) { die("$proj_err_mes"); }
  else {
    // loop over childs
    $result = db_query("select ID
                        from ".DB_PREFIX."projekte 
                       where parent = '$ID'") or db_die();  
    while ($row = db_fetch_row($result)) {
      check_subrecord($row[0], $new_parent_rootID); 
    }     
  }
}

function move_branch($ID, $field, $days) {
  // get the value
  $result = db_query("select ".$field."
                        from ".DB_PREFIX."projekte
                       where ID = $ID") or db_die();  
  $row = db_fetch_row($result);           
  $olddate = explode('-',$row[0]);
  $newdate = date("Y-m-d", mktime(0, 0, 0, $olddate[1], $olddate[2]+$days, $olddate[0]));
  $result = db_query("update ".DB_PREFIX."projekte
                         set ".$field." = '".$newdate."' 
                       where ID = $ID") or db_die();  
  // loop over childs
  $result = db_query("select ID
                        from ".DB_PREFIX."projekte 
                       where parent = '$ID'") or db_die();  
  while ($row = db_fetch_row($result)) { move_branch($row[0],$field, $days); }  
}

?>