<?php

// dbman_lib.inc.php.inc.php - PHProjekt Version 4.1
// copyright    2000-2003 Albrecht Guenther  ag@phprojekt.com
// www.phprojekt.com
// Author: Albrecht Guenther

// space for element names which are displayed on the left side before the input element
$text_width=75;

// check whether lib.inc.php has been included
if (!defined("lib_included")) { die("Please use index.php!"); } 
   
// fetch all elements of a form, it's properties and the related values if an ID is given
function build_array($module, $ID) {
 global $mode; 

  // determine whether the list of the form mode is active - and sort accordingly
 $mode == 'view' ? $sort = 'list_pos': $sort = 'form_pos';
  
// form array for fields
  $result = db_query("select db_name, form_name, form_type, form_tooltip, form_pos, form_regexp, 
                              form_default, form_select, list_pos, filter_show, list_alt, db_table,
                              form_colspan, form_rowspan  
                         from ".DB_PREFIX."db_manager 
                        where db_table like '$module' and 
                              db_inactive <> '1'
                     order by ".$sort) or db_die();                                                              
  while ($row = db_fetch_row($result)) {
    $fields[$row[0]] = array( 'form_name' => $row[1],
                              'form_type' => $row[2],
                              'form_tooltip' => $row[3],
                              'form_pos' => $row[4], 
                              'form_regexp' => $row[5],    
                              'form_default' => $row[6],    
                              'form_select' => $row[7],
                              'list_pos' => $row[8], 
                              'filter_show' => $row[9],    
                              'list_alt' => $row[10],
                              'db_table' => $row[11],
                              'form_colspan' => $row[12],
                              'form_rowspan' => $row[13]);
  }
  
  foreach($fields as $field_name => $field_values) { $db_fields[] = $field_name; } 
  // fetch the values of this record - either with a valid ID (>0) or as dummy entries
  if ($ID > 0) {
    $i = 0; 
    $result = db_query("select ".implode(',',$db_fields)."  
                          from ".DB_PREFIX.$module." 
                         where ID = '$ID'") or db_die();                  
    $row = db_fetch_row($result); 
    for($i=0; $i < count($row); $i++) {
      $fields[$db_fields[$i]]['value'] = $row[$i];
    }
  } 
  else {
    for ($i=0; $i < count($db_fields); $i++) {
      $fields[$db_fields[$i]]['value'] = '';    
    }
  }
  return $fields;                       
}     
 
// output of all elements of a form, uses the function form_element to display the different types of form elements like text, textarea  etc.         
function build_form($fields) {
  global $settings;
  
  // determine how many rows should be displayed 
  if     ($settings['screen'] > 1000) {$rows = 2; }
  elseif ($settings['screen'] > 1250) {$rows = 3; }
  else $rows = 1;
  $i=0;
            
  echo "<table border=1 rules=cols cellpadding=0 cellspacing=0><tr>";
  foreach($fields as $field_name => $field) {
    form_element($field, $field_name);
    // raise $i if we occur a rowspan flag 
    if ($field['form_rowspan'] > 1) {
      $n_rowspan = $field['form_rowspan']-1;
      if ($field['form_colspan'] > 1) $n_colspan = $field['form_colspan'];
    }      
    if ($field['form_colspan'] > 1) { $i = $i + $field['form_colspan']; }                                                                       
    // new column after this element?
    if ($i >= $rows) { 
      echo "</tr><tr>";
      if ($n_rowspan > 0) {
        $i = 1;
        $i = $i + $n_colspan;
        $n_rowspan--; 
      }
      else {
        $i = 0;
        $n_colspan=0;
      }         
    }
    else $i++;
  }   
  echo "</tr></table>";
}

// adds the reagexp definition for the javascript check at submission of form
function build_regexp($regexp, $field_name) {
  global $forms_19;
  if ($regexp <> '') { 
    return "onBlur=\"reg_exp('frm','".$field_name."','".$forms_19."',/".$regexp."/)\"";
    }
}

// replaces strings with a dollaras prefix with the value of the variables of the same name
function enable_vars($string) { return preg_replace_callback('#\$(\w+)#si', 'enable_vars2', $string); }
function enable_vars2($varname) { return $GLOBALS[$varname[1]]; }

// prepares the output of all files/values for the green button
function alt_values($fields) {
  global $img_path; 
  foreach ($fields as $field_name => $field) {
    if ($field['list_alt'] == '1') {
      $string .= enable_vars($field['form_name']).": ".$field['value']."\n";
    }
  }
  return "&nbsp;<img src='$img_path/b.gif' alt='".$string."' border=0 width=7>";
} 

// foreach defined form element type the html snippet
function form_element($field, $field_name) {    
  global $ID, $quickmail, $read_o, $admin_text64, $text_width;
           
  // if it's a new record, give the default value predefined in the db
  if (!$ID) $field['value'] = enable_vars($field['form_default']);

  switch($field['form_type']) { 
  
    // display: no chance to edit this, just plain view   
    case 'display':
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>";
      echo $field['value'];
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo "</td></table></td>\n";      
      break; 
      
    // text-create means that the user can only insert a text at the time he craetes the record but cannot modify the value later   
    case 'text_create':
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>\n";
      if (!$ID) {
        echo "<input type='text' size=".set_size($field)." name='". $field_name."' value='".$field['value']."'";
        if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
        echo read_o($read_o)." ".build_regexp($field['regexp'], $field_name).">";
      }
      else echo $field['value'];  
      echo "</td></table></td>\n";       
      break;      
        
    // textarea - no comment  
    case 'textarea':
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>\n";
      echo "<textarea ".set_size($field)." name='". $field_name."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o).">".$field['value']."</textarea>";
      echo "</td></table></td>\n";        
      break; 
      
    // single checkbox - another 'no comment' 
    case 'checkbox':     
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>\n";
      echo "<input type='checkbox' name='".$field_name."' value='yes'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      if ($field['value'] <> '') echo " checked";
      echo read_o($read_o).">\n"; 
      echo "</td></table></td>\n";       
      break;
      
    // range of predefined, fixed values from the field 'form_select'           
    case 'select_values':           
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>\n";
      echo "<select name='". $field_name."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o).'>';
      foreach(explode('|',$field['form_select']) as $select_value) {
        echo "<option value='".$select_value."'";
        if ($select_value == $field['value']) echo " selected";
        echo '>'.$select_value;
      }
      echo "</select></td></table></td>\n";      
      break;
      
    // multiple select        
    case 'select_multiple':           
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>\n";
      echo "<select multiple size=".set_size($field)." name='". $field_name."[]'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o).'>'; 
      // move previously selected values into array
      $selected = explode('|',$field['value']);
      foreach(explode('|',$field['form_select']) as $select_value) {
        echo "<option value='".$select_value."'";
        if (in_array($select_value,$selected)) echo " selected";
        echo '>'.$select_value;
      }
      echo "</select></td></table></td>\n";      
      break;     
    
    // fetches the result of a sql statement and displays it in a select box  
    case 'select_sql': 
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>\n";
      echo "<select name='". $field_name."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o).'>';      
      $result = db_query(enable_vars($field['form_select']));                                                     
      while ($row = db_fetch_row($result)) {    
        echo "<option value='".implode(',',$row)."'";
        if (implode(',',$row) == $field['value']) echo " selected";
        echo ">".implode(',',$row);
      }
      echo "</select></td></table></td>\n";      
      break;

      // combines the option to select an entry from previous records or to insert a new value
    case 'select_category': 
      // first the previous values
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>\n";
      echo "<select name='". $field_name."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'\n"; }
      echo read_o($read_o)."><option value=''>";
      // define access rule
      $result = db_query("select distinct ".$field_name." 
                            from ".DB_PREFIX.$field['db_table']."
                           where ".enable_vars($field['form_select'])." and
                                 ".$field_name." <> '' 
                        order by ".$field_name) or db_die();
      while ($row = db_fetch_row($result)) {  
        echo "<option value='".$row[0]."'";
        if ($row[0] == $field['value']) echo " selected";
        echo ">".implode(',',$row);
      }
      echo "</select> \n";  
      echo $admin_text64."<input type='text' size=".set_size($field)." name='new_category'\n";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'\n"; }
      echo read_o($read_o)."></td></table></td>\n";   
      break;          
 
    case 'upload':
      list($filename,$tempname) = explode('|',$field['value']);
      
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>\n";
      echo "<input type='file' size=".set_size($field)." name='". $field_name."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o).'>';
      if ($filename <> '') echo "<br>(<a href='../docs/".$tempname."' target=_blank>".$filename."</a>)";
      echo "</td></table></td>\n";                
      break;
        
    case 'date':              
      // if no value is given, take today
      if (!$field['value']) $field['value'] = date("Y-m-d");
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>\n";
      echo "<input type='text' size=".set_size($field)." name='". $field_name."' value='".$field['value']."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o)."></td></table></td>\n";       
      break;  

      // mail address - gives link zu mail reader
    case 'email': 
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      if ($ID > 0) echo "<a href=\"javascript:mailto('email',0,'".(SID?$PHPSESSID:"")."',$quickmail)\">".enable_vars($field['form_name'])."</a>";
      else echo enable_vars($field['form_name']);
      echo "</td><td><input type='text' size=".set_size($field)." name='". $field_name."' value='".$field['value']."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o)."></td></table></td>\n";   
      break; 
      
      // url - opens address in a new window
    case 'url': 
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      if ($ID > 0) echo "<a href=\"javascript:go_web();\">".enable_vars($field['form_name'])."</a>";
      else echo enable_vars($field['form_name']);
      echo "</td><td><input type='text' size=".set_size($field)." name='". $field_name."' value='".$field['value']."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o)."></td></table></td>\n";   
      break;
                 
    
      // field element 'text' is default
    default:
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>";
      echo " <input type='text' size=".set_size($field)." name='". $field_name."' value='".$field['value']."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o)." ".build_regexp($field['form_regexp'], $field_name).">\n"; 
      echo "</td></table></td>\n";       
      break;
  }
}                  

// ***********
// functions to upload, modify and delete a file in the form 
function upload_file_create($field_name) {
  global $HTTP_POST_FILES; 
  $tempname = '';
  srand((double)microtime()*1000000);
  $char = "123456789abcdefghijkmnopqrstuvwxyzABCDEFGHIJKLMANOPQRSTUVWXYZ";
  while (strlen($tempname) < 12) { $tempname .= substr($char,(rand()%(strlen($char))),1); }
  // add extension to random name
  $tempname .= strstr($HTTP_POST_FILES[$field_name]['name'],'.');
  // write file  
  copy($HTTP_POST_FILES[$field_name]['tmp_name'],'../docs/'.$tempname);
  // since only one field as available we have to store both values together
  return $HTTP_POST_FILES[$field_name]['name'].'|'.$tempname;
} 

function upload_file_delete($field_name, $ID, $module) {
  // fetch tempname from db
  $result = db_query("select $field_name 
                        from ".DB_PREFIX.$module." 
                       where ID = '$ID'") or db_die();
  $row = db_fetch_row($result); 
  // is there any previous file listed?
  if ($row[0] <> '') {  
    
    list(,$t2) = explode('|',$row[0]);    
    unlink('../docs/'.$t2);
  }
}

function upload_file_modify($field_name, $ID, $module) {
  // 1. step: delete the old file
  upload_file_delete($field_name, $ID, $module); 
  // 2. step
  return upload_file_create($field_name);
}
// end functions upload
// ****************  

// return string with results for 'select multiple'
function store_select_multiple($field) {
  global $HTTP_POST_VARS; 
  if ($HTTP_POST_VARS[$field] <> '') return implode('|',$HTTP_POST_VARS[$field]);
}

// define size of element and probably colspan /rwospan
function set_span($field) { 
  if ($field['form_rowspan'] > 1) {
    $rows = $field['form_rowspan'];
    $size = " rowspan=$rows";  
  }
  if ($field['form_colspan'] > 1) {
    $cols = $field['form_colspan'];  
    $size .= " colspan=$cols";
  }
  return $size;
}

// return size of input element - especially if we have a rowspan/colspan > 1                                     
function set_size($field) { 
  global $default_size, $text_width;
  
  if (!$default_size) $default_size1 = 40;
  else $default_size1 = $default_size; 
  if ($field['form_colspan'] > 1) { 
    $default_size1 = $default_size1*$field['form_colspan']+$text_width/4*($field['form_colspan']-1); 
  }
  
  // for some elements we have to calculate another size number for a nice table layout
  switch ($field['form_type']) {
    case 'upload':
      return ($default_size1 - 22);
      break;
    case 'textarea':  
      $hor_size=floor($default_size1*0.7);
      if ($field['form_rowspan'] > 1) { $ver_size = $field['form_rowspan']*2 - 1; }                              
      else $ver_size = 2;
      return 'rows='.$ver_size.' cols='.$hor_size; 
      break;
    case 'select_multiple': 
      if ($field['form_rowspan'] > 1)  { $ver_size = $field['form_rowspan']*2 - 1; }
      else $ver_size = 2;      
      return $ver_size;
      break;
    case 'select_category':
      return ($default_size1 - 20);     
      break;
    default:
      return $default_size1;
      break;  
  }
}

 
?>