<?php

// mail_view.php - PHProjekt Version 4.1
// copyright    2000-2003 Albrecht Guenther  ag@phprojekt.com
// www.phprojekt.com
// Author: Albrecht Guenther

// check whether the lib has been included - authentication!
if (!defined("lib_included")) { die("Please use index.php!"); }

// check role
if (check_role("mail") < 1) { die("You are not allowed to do this!"); }

// sadly enough here comes the third check whether the imap library is installed ;-)
if (!function_exists('imap_open')) { die("Sorry but the full functionality of the mail client requires the imap-extension
                                          of php. Please ensure that this extension is active on your system.<br>
                                          In the meantime if you want to use the mail send module, set $quickmail=1; in the config.inc.php"); }

$include_path = $path_pre."lib/email_getpart.inc.php";
include_once $include_path;                                          
                                          
// unset all references to attachments and let the script create them
session_unregister("file_ID");
unset($file_ID);
// seems that the last function doesn't work properly on some php installations -> additional function to make sure that ...
$file_ID = array();

// array for filter fields
$fields = array( "all" => "$rts_23", "subject" => "$mail_text1", "body" => "$mail_text21" , "sender" => "$mail_text22" );
// fields for rules
$rules_fields = array("subject" => "$mail_text1", "body" => "$mail_text21", "sender" => "$mail_text22",
                      "recipient" => "$mail_text24", "cc" => "Cc");
// action for rules
$rules_action  = array("copy" => "$copy_it", "move" => "$move_it", "delete" => "$delete_it");

function sendmail_link($mailadress,$m_name) {
  global $quickmail, $sid;
  if ($quickmail > 0) {
    echo "<td><a href='mail.php?mode=send_form&recipient=$mailadress".$sid."')>$m_name</a>&nbsp;</td>\n";
  }
  else { echo "<td><a href='mailto:$mailadress'>$m_name</a>&nbsp;</td>\n"; }
}

function mail_delete($delete_ID) {
  global $user_ID, $path_pre;
  $result = db_query("select ID, von, typ 
                        from ".DB_PREFIX."mail_client 
                       where ID = '$delete_ID'") or db_die();
  $row = db_fetch_row($result);
  // check permission
  if ($row[0] == 0) { die("no entry found."); }
  if ($row[1] <> $user_ID) { die("You are not allowed to do this!"); }
  // delete attachments
  if ($row[2] <> "d") {
    // select files
    $result2 = db_query("select tempname 
                           from ".DB_PREFIX."mail_attach 
                          where parent = '$delete_ID'") or db_die();
    while ($row2 = db_fetch_row($result2)) {
      $path = $path_pre."attach/$row2[0]";
      unlink($path);
    }
    // delete records
    $result2 = db_query("delete from ".DB_PREFIX."mail_attach 
                          where parent = '$delete_ID'") or db_die();
  }
  elseif ($row[2] == "d") {
    // free rules
    $result2 = db_query("update ".DB_PREFIX."mail_rules 
                            set parent = '' 
                          where parent = '$delete_ID'") or db_die();
  }
  // delete record itself
  $result2 = db_query("delete from ".DB_PREFIX."mail_client 
                        where ID = '$delete_ID'") or db_die();
  if ($row[2] == "d") del($row[0]); // look for files in the subdirectory
}

// show html output in separate window

if ($action == "showhtml") {

  // fetch original data
  if ($ID) {
    $result = db_query("select ID, von, body_html 
                          from ".DB_PREFIX."mail_client 
                         where ID = '$ID'") or db_die();
    $row = db_fetch_row($result);
    // check permission
    if ($row[0] == 0) { die("no entry found."); }
    if ($row[1] <> $user_ID) { die("You are not allowed to do this!"); }
  }
  $body = stripslashes($row[2]);
  // add images into the html code
  $i = 0;
  while ($pos1 = strpos($body,"cid")) {
    $i++;
    $i2 = 0;
    $b1 = explode("cid",$body,2);
    $b2 = explode("\"",$b1[1],2);
    $result3 = db_query("select tempname 
                           from ".DB_PREFIX."mail_attach 
                          where parent = '$row[0]'") or db_die();
    while ($row3 = db_fetch_row($result3)) {
      $i2++;
      if ($i == $i2) { $imgstring = $path_pre."attach/$row3[0]"; }
    }
    $body = $b1[0].$imgstring."\"".$b2[1];
  }
  // look for scripts in the string and try to avoid poisoned code ...
  $body = eregi_replace("<script","&lt;script",$body);
  // look for images which should be loaded from outer space ...
  $body= @eregi_replace("<img(.*)http(.*)>","", $body);

  // output of the body from message an stop
 die($body);
}

// include javascript for form check
if (ereg("accounts|rules|sender",$sender)) {echo "<script language='JavaScript' src='$lib_path/chkform.js' type='text/javascript'></script>\n";}

// open and close directory
if ($element_mode == "open") {
  $arrdir[$ID] = "1";
  $action = "";
}
elseif ($element_mode == "close"){
  $arrdir[$ID] = "";
  $action = "";
}
reg_sess_vars(array("arrdir"));
// dialog for options: accounts, rules and switch 'don't delete messages after reading'
if ($action == "options") { include_once("./mail_options.php"); }

// ********
// accounts
if ($action == "accounts"){ include_once("./mail_accounts.php"); }
// end part mail accounts

// ********
// sender / signature
if ($action == "sender"){ include_once("./mail_sender.php"); }
// end part mail sender

// *****
// rules
if ($action == "rules") { include_once("./mail_rules.php"); }
// end part rules


// ***************
// fetch new mails
// ***************
if ($action == "fetch_new_mail") {
  // if no special account is given - loop over all mail accounts
  if (!$account_ID) { 
    $result = db_query("select ID, von, accountname, hostname, type, username, password 
                          from ".DB_PREFIX."mail_account 
                         where von = '$user_ID' and collect = 1") or db_die(); 
  }
  // otherwise build the query just for the chosen account
  else {  
    $result = db_query("select ID, von, accountname, hostname, type, username, password
                          from ".DB_PREFIX."mail_account 
                         where von = '$user_ID' and 
                               ID = '$account_ID'") or db_die(); }
  while ($row = db_fetch_row($result)) { 
    include("./mail_fetch.php"); 
    $list .= $list_mails; 
  }
  echo $list;
  
  // printout the list of mails
  echo "<table cellpadding=1 cellspacing=1 border=1>\n";
  if (isset($mail_arr)) foreach ($mail_arr as $m_subject => $m_sender) { echo "<tr><td>$m_subject</td><td>$m_sender</td></tr>\n"; }
  echo "</table>\n";
  
  $action = "";
} // end fetch mail
// *************


// ***********************
// actions for directories

if ($action == "update") {
  // check for same record name
  $result = db_query("select ID, subject 
                        from ".DB_PREFIX."mail_client 
                       where typ like 'd'") or db_die();
  while ($row = db_fetch_row($result)) {
    if ($row[0] <> $ID and $row[1] == $subject) { die("$datei_text19! <br><a href='mail.php?mode=view&action=form&page=$page&perpage=$perpage&up=$up&sort=$sort$sid'>$back</a>"); }
  }
  // assign category
  if (!$kat) { $kat = $kat2; }

  // copy record with new values
  if ($c_m == "c") {
    $result = db_query("select ID,von,subject,body,sender,recipient,cc,kat,remark,date_received,touched,typ,
                               parent,date_sent,header,replyto,acc,body_html  
                          from ".DB_PREFIX."mail_client 
                         where ID = '$ID'") or db_die(); // fetch missing values from old record
    $row = quote_runtime(db_fetch_row($result));
    $result = db_query("insert into ".DB_PREFIX."mail_client 
                               (   ID,        von,   subject,  body,     sender,   recipient, cc,        kat,   remark,date_received,touched,typ,  parent,date_sent,  header )   
                        values ($dbIDnull,'$user_ID','$row[2]','$row[3]','$row[4]','$row[5]','$row[6]','$kat','$remark','$dbTSnull',  1,     'm','$parent',$row[13],'$row[14]')") or db_die();
    // copy attachments as well
    copy_attachments($ID);
  }
  // update record or move item
  else {
    // if type = dir, then allow to change the name
    if ($typ == "d") { $dirname2 = "subject = '$dirname',"; }
    // update for all types (mail, dir)
    $result = db_query("update ".DB_PREFIX."mail_client 
                           set $dirname2 
                               remark='$remark',
                               kat='$kat',
                               parent='$parent' 
                         where ID = '$ID'") or db_die();
  }
  $action = "";
}

// create new dir
elseif ($action == "dir") {
  if (!$dirname) {  // filename doesn't exists?
    echo "$datei_text1";
    $action = "form";
  }
  // check for same record name
  $result = db_query("select subject 
                        from ".DB_PREFIX."mail_client 
                       where typ like 'd'") or db_die();
  while ($row = db_fetch_row($result)) {
    if ($row[0] == $subject) {
      echo "$datei_text19!";
      $error = 1;
    }
  }
  // assign category
  if (!$kat) { $kat = $kat2; }

  // write record to db
  if (!$error) {
    $result = db_query("insert into ".DB_PREFIX."mail_client 
                               ( ID,         von,     subject,    kat,   remark,date_received,typ,  parent )
                        values ($dbIDnull,'$user_ID','$dirname','$kat','$remark','$dbTSnull', 'd','$parent')") or db_die();
    $action = "";
  }
}

// delete mails: single deletion via the form or multiple via the list
elseif ($action == "delete") {
  if ($delete_ID > 0) { mail_delete($delete_ID); }
  if ($delete_mail[0]) {
    foreach($delete_mail as $delete_ID)  { mail_delete($delete_ID); }
  }
  $action = "";
}


//*******
// Dialog
//*******

// ****
// Form

if ($action == "form") {
  //js: forces to enter a name
  echo "<script language='JavaScript' src='$lib_path/chkform.js' type='text/javascript'></script>\n";
  echo "<table bgcolor=$bgcolor2 cellspacing=0 cellpadding=3 border=1 width=500>\n";
  // title and help link
  echo "<td width=250><a href='$doc/quickmail.html' target=_blank><b>$mail_text9</b></a></td>\n";
  // link for creating directories
  echo "<td width=150>$con_text4: <a href='mail.php?mode=view&action=form&sort=$sort&up=$up&form=d$sid'>$directory</a></td>\n";
  // back link
  echo "<td><a href='mail.php?mode=view&page=$page&perpage=$perpage&up=$up&sort=$sort$sid'>$back</td></table><br>\n";

  // Formular - modify form
  echo "<table border=1 cellspacing=0 cellpadding=3 bgcolor=$bgcolor2 width=500>\n";

  // fetch original data
  if ($ID) {
    $result = db_query("select ID, von, subject, body, sender, recipient, cc, kat, remark, date_received, touched, date_sent, body_html
                          from ".DB_PREFIX."mail_client 
                         where ID = '$ID'") or db_die();
    $row = db_fetch_row($result);
    // check permission
    if ($row[0] == 0) { die("no entry found."); }
    if ($row[1] <> $user_ID) { die("You are not allowed to do this!"); }
  }

  // form for mails
  if ($form <> "d") {
    // mark mail as red.
    if(!$row[10]) {
      $result = db_query("update ".DB_PREFIX."mail_client 
                             set touched=1 
                          where ID = '$ID'") or db_die();
    }

    echo "<form method=post action='mail.php'>\n";
    echo "<input type='hidden' name='mode' value='view'>\n";
    echo "<input type=hidden name='typ' value='m'>\n";

    // format 'sender' string from db
    if (ereg("&lt;",$row[4])) {$sender=explode("&lt;",$row[4]);$sender1=substr($sender[1],0,-4);$sender2=$sender[0];}
    elseif (ereg("<",$row[4])) {$sender=explode("<",$row[4]);$sender1=substr($sender[1],0,-1);$sender2=$sender[0];}
    else { $sender2 = $row[4]; }

    // create receiver string
    // if there are several receivers, split them
    $receiver_string = "";
    if (ereg(", ",$row[5])) { $receivers = explode(", ",$row[5]); }
    else { $receivers[0] = $row[5]; }
    for ($i=0; $i < count($receivers); $i++) {
      $rec = explode("<",$receivers[$i]);
      // try to find the email adress
      // 1. option: test<test@test.de> -> split was successful
      if ($rec[1] <> "") { $receiver1 = html_out(substr($rec[1],0,-1)); }
      // 2. option text@test.de -> take the email adress as it is
      else { $receiver1 = html_out($rec[0]); }
      $receiver2 = html_out($rec[0]);
      if ($i > 0) { $receiver_string .= "; "; }
      $receiver_string .= "<a href='mail.php?mode=send&form=email&recipient=$receiver1$sid'>$receiver2</a>";
    }
    // echo sender and receiver string
    echo "<tr><td colspan=3><b>$mail_text9</b> $forum_text8: <a href='mail.php?mode=send&form=email&recipient=$sender1$sid'>$sender2</a>";
    echo " - $mail_text46: $receiver_string &nbsp; \n";

    // reply, reply all and forward
    echo "<a href='mail.php?mode=send_form&form=email&action2=reply&ID=$row[0]$sid'><img src='$img_path/arrowleft.gif' alt='$mail_text25' title='$mail_text25' border=0 width=10></a>&nbsp;\n";
    echo "<a href='mail.php?mode=send_form&form=email&action2=replyall&ID=$row[0]$sid'><img src='$img_path/replyall.gif' alt='$mail_text25' title='$proj_text8 $mail_text25' border=0 height=12></a>&nbsp;\n";
    echo "<a href='mail.php?mode=send_form&form=email&action2=forward&ID=$row[0]$sid'><img src='$img_path/arrowright.gif' alt='$mail_text26' title='$mail_text26' border=0 width=10></a>&nbsp;</td>\n";
    echo "</td></tr>";

        // cc string
    if ($row[6]) {
      $cc_string = "";
      if (ereg(", ",$row[6])) { $ccs = explode(", ",$row[6]); }
      else { $ccs[0] = $row[6]; }
      for ($i=0; $i < count($ccs); $i++) {
        $ccstrings = explode("<",$ccs[$i]);
        $cc1 = html_out(substr($ccstrings[1],0,-1));
        $cc2 = html_out($ccstrings[0]);
        if ($i > 0) { $cc_string .= "; "; }
        $cc_string .= "<a href='mail.php?mode=send&form=email&recipient=$cc1$sid'>$cc2</a>";
      }
    }
    echo "<tr><td>cc:</td><td colspan=2>$cc_string &nbsp;</td></tr>\n";

    // title
    echo "<tr><td width=50>$mail_text1:</td><td colspan=2>$row[2] </td></tr>\n";

    // body: add linebreaks
    $body = $row[3];
    // try to avoid scripting which can be poisoned
    //$body = eregi_replace("<script","&lt;script",$body);
    $body = html_out($body);
    // convert web and mail links to clickable links ... but only for a text mail!
    if (!eregi("<href=",$body) and !eregi("mailto:",$body)) {
      $body = @eregi_replace("(((f|ht){1}tp://)[a-zA-Z0-9@:%_.~#-\?&]+[a-zA-Z0-9@:%_~#\?&])", "<a href=\"\\1\" target=\"_blank\">\\1</a>", $body); //http
      $body = @eregi_replace("([[:space:]()[{}])(www.[a-zA-Z0-9@:%_.~#-\?&]+[a-zA-Z0-9@:%_~#\?&])", "\\1<a href=\"http://\\2\" target=\"_blank\">\\2</a>", $body); // www.
      $body = @eregi_replace("([_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,3})","<a href=\"mailto:\\1\">\\1</a>", $body); // @
    }
    $body = nl2br($body);

    // show link to html output and display body in plain text
    echo "<tr><td>$mail_text21:<br> \n";
    if ($row[12] <> "") { echo "<a href='mail.php?mode=view&action=showhtml&ID=$row[0]$sid' target=_blank>html $mail_text21</a></td>\n"; }
    echo "<td>$body</td></tr>\n";

    // date
    /* we should use ISO date format
    $date_received = substr($row[9],6,2).".".substr($row[9],4,2).".".substr($row[9],0,4)." ".substr($row[9],8,2).".".substr($row[9],10,2);
    $date_sent = substr($row[13],6,2).".".substr($row[13],4,2).".".substr($row[13],0,4)." ".substr($row[13],8,2).".".substr($row[13],10,2);
    */
    $date_received = show_iso_date1($row[9]);
    $date_sent = show_iso_date1($row[11]);
    echo "<tr><td colspan=2>\n";

    echo "<table bgcolor=$bgcolor2 cellspacing=0 cellpadding=3 border=1 width=500>\n";
    echo "<tr><td colspan=3>$mail_text44: $date_sent - $mail_text45: $date_received</td></tr>\n";

    // look for attachments
    // initialize random string for ID
    srand ((double)microtime()*1000000);
    $char = "0123456789ABCDEFGHIJKLMANOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";

    echo "<tr><td colspan=3>$mail_text23: &nbsp;\n";
    $result3 = db_query("select ID, parent, filename, tempname, filesize 
                           from ".DB_PREFIX."mail_attach 
                          where parent = '$ID'") or db_die();
    while ($row3 = db_fetch_row($result3)) {
      $rnd = "";
      while (strlen($rnd) < 12) { $rnd .= substr($char,(rand()%(strlen($char))),1);}
      // determine filesize
      if ($row3[4] > 1000000)  {$fsize = floor($row3[4]/1000000)." M";}
      elseif ($row3[4] > 1000) {$fsize = floor($row3[4]/1000)." k";}
      else {$fsize = $row3[4];}
      // write data to the array for downloading
      $file_ID[$rnd] = "$row3[2]|$row3[3]|$row3[0]";
      echo "<a href='mail_down.php?rnd=$rnd$sid' target=_blank>$row3[2] ($fsize)</a><br>\n";
    }
    reg_sess_vars(array("file_ID"));
    echo "</td></tr><input type=hidden name='action' value='update'>\n";
  }

   // form for directories
  elseif ($form == "d") {
    echo "<form method=post action='mail.php' name='frm' onSubmit=\"return chkForm('frm','dirname','$opt_bm4!')\">\n";
    echo "<input type='hidden' name='mode' value='view'>\n";
    echo "<input type=hidden name=typ value='d'>\n";
    if ($ID) echo "<input type=hidden name='action' value='update'>\n";
    else     echo "<input type=hidden name='action' value='dir'>\n";
    echo "<tr><td colspan=3><b>$directory</b><br>\n";
    echo "<tr><td>$datei_text3:</td><td colspan=2><input type=text name=dirname size=20 value='$row[2]'></td></tr>\n";
  }

  // continue with rest of the form which applies to all three types of records

  // move or copy
  echo "<tr><td width=50>$directory: </td><td>\n";
  // show copy and move buttons only in case of altering data
  if ($ID) {
  // copying of dirs at the moment not possible
    if ($form <> "d") echo "<input type=radio name='c_m' value='c'>$copy_it\n";
    echo " <input type=radio name='c_m' value='m'>$move_it<br>$datei_text17\n";
  }

  echo "&nbsp;</td><td><select name='parent'> <option value='0'>\n";
  $result2 = db_query("select ID, subject 
                         from ".DB_PREFIX."mail_client 
                        where typ like 'd' and 
                              von = '$user_ID'") or db_die();
  while ($row2 = db_fetch_row($result2)) { 
    if ($form <> "d" or $row[0] <> $row2[0]) {  // avoid that a dir will be subdir of itself
      echo "<option value='$row2[0]'";
      if ($row[12] == $row2[0]) echo " selected";
      echo ">$row2[1]\n";
    }
  }
  echo "</select><br></td></tr>\n";

  // category
  echo "<tr><td width=70>$datei_text5:</td>\n";
  echo "<td>$con_text4: <br> <input type=text name=kat size=20></td>\n";
  // show different categories
  echo "<td width=100>$admin_text64:<br><select name=kat2>&nbsp;<option value=''>\n";
  $result2 = db_query("select distinct kat 
                         from ".DB_PREFIX."mail_client 
                        where von = '$user_ID'") or db_die();
  while ($row2 = db_fetch_row($result2)) {
    if ($row2[0] <> '') {
      echo "<option value='$row2[0]'";
      if ($row[7] == $row2[0]) echo " selected";
      echo ">$row2[0]\n";
    }
  }
  echo "</select></td></tr>\n";

  // remark
  echo "<tr><td colspan=3>$datei_text4:<br><textarea name=remark cols='37' rows='4'>$row[8]</textarea></td></tr></table>\n";

  echo "<input type=hidden name='name' value='$user_name'>\n";
  if(SID) echo "<input type=hidden name='PHPSESSID' value='$PHPSESSID'>\n";
  echo "<input type=hidden name='sort' value='$sort'>\n";
  echo "<input type=hidden name='up' value='$u'p>\n";
  echo "<input type=hidden name='page' value='$page'>\n";
  echo "<input type=hidden name='perpage' value='$perpage'>\n";
  echo "<input type=hidden name='ID' value='$ID'>\n";   // $ID set? -> only record update

  // submit button
  echo "<table bgcolor=$bgcolor2 cellspacing=0 cellpadding=3 border=1 width=500>\n";
  if ($ID) {echo "<tr><td><input name=update value='$rts_39' type=submit></form>\n";
                  # Insert by Andreas Kansok
                   echo "&nbsp; </td>\n";}

  else {echo "<tr><td><input type=submit name=upload value='$submit'></form> &nbsp; </td>\n";}

  // delete button
  if ($ID) {
    echo "<td><form action='mail.php' method='post'>\n";
    echo "<input type='hidden' name='mode' value='view'>\n";
    if(SID) echo "<input type=hidden name='PHPSESSID' value='$PHPSESSID'>\n";
    echo "<input type=hidden name='sort' value='$sort'>\n";
    echo "<input type=hidden name='up' value='$up'>\n";
    echo "<input type=hidden name='page' value='$page'>\n";
    echo "<input type=hidden name='perpage' value='$perpage'>\n";
    echo "<input type=hidden name='action' value='delete'>\n";
    echo "<input type=hidden name='delete_ID' value='$row[0]'>\n";
    echo "<input type=submit value='$delete_it'></form></td>\n";

    // print button
    echo "<td><form action='../misc/print.php' method='post' target=_blank>\n";
    if(SID) echo "<input type=hidden name='PHPSESSID' value='$PHPSESSID'>\n";
    echo "<input type=hidden name='module' value='mail'>\n";
    echo "<input type=hidden name='ID' value='$ID'>\n";
    echo "<input type=submit name='print' value='$print'></form></td>\n";
  }

  // back button
  echo "<td><form action='mail.php' method='post'>\n";
  echo "<input type='hidden' name='mode' value='view'>\n";
  if(SID) echo "<input type=hidden name='PHPSESSID' value='$PHPSESSID'>\n";
  echo "<input type=hidden name='sort' value='$sort'>\n";
  echo "<input type=hidden name='up' value='$up'>\n";
  echo "<input type=hidden name='page' value='$page'>\n";
  echo "<input type=hidden name='perpage' value='$perpage'>\n";
  echo "<input type=submit value='$back'></form></td>\n";
  echo "</tr></table>\n";

  echo "</td></tr></table>\n";
}

// *********
// list view
// *********

if (!$action) {
  echo "<table border=0 cellspacing=0 cellpadding=2 bgcolor=$bgcolor2 rules=none><tr>";
  echo "<form action='mail.php' method='post'>";
  if(SID) echo "<input type=hidden name='PHPSESSID' value='$PHPSESSID'>\n";
  echo "<input type=hidden name='mode' value='view'>\n";
  echo "<input type=hidden value='$sort' name='sort'>\n";
  echo "<input type=hidden value='$up' name='up'></td></tr>\n";

  // title and help link
  echo "<td><a href='$doc/quickmail.html' target=_blank><b>$mail_text9</b></a>\n";
  // set filter
  echo "<td>| $datei_text14:</td><td><input type=text size=15 name='keyword' value=$keyword></td><td>$rts_22</td>\n";
  echo "<td><select name='filter'>\n";
  foreach ($fields as $field1 => $field2) {  
    echo "<option value='$field1'";
    if ($field1 == $filter) { echo " selected"; }
    echo ">$field2\n";
  }
  echo "</select></td>\n";
  // define threads/page and expanded/collapsed tree
  // default:
  echo "<td> &nbsp; | &nbsp; <input type='radio' name='tree_mode' value='open'";
  echo ">$forum_text10 &nbsp;";
  echo "<input type='radio' name='tree_mode' value='close'";
  echo ">$forum_text11 &nbsp; | &nbsp; $items ";
  // unset the whole arary
  if ($tree_mode == "close"){
   $arrdir = $arr_empty;
   reg_sess_vars(array("arrdir"));
  }
  
  // perpage select box
  echo "<td>&nbsp;<select name='perpage'>\n";
  foreach ($perpage_values as $j) {
    echo "<option value='$j'";
    if ($j == $perpage) { echo " selected"; }
    echo ">$j\n";
  }
  echo "</select></td>\n";
  echo "<td>&nbsp;<input type=image src='$img_path/los.gif' border='0' id=tr>&nbsp;&nbsp;";

  // define filter
  if ($keyword) {
    if ($filter == "all" or $filter == '') { $where = "(subject like '%$keyword%' or body like '%$keyword%' or sender like '%$keyword%'or kat like '%$keyword%')"; }
    else { $where = "$filter like '%$keyword%'"; }
  }
  // no filter? -> straight list, begin with first level
  else $where = "parent = 0";

  //  define 'next' & 'previous' button, look for max number
  $result = db_query("select count(ID) 
                        from ".DB_PREFIX."mail_client 
                       where $where and 
                             von = '$user_ID'") or db_die();
  $row = db_fetch_row($result);
  if ($row[0] > $perpage) { echo "<tr>\n"; }
  $page_n = $page + 1;
  $page_p = $page - 1;
  if ($page) {echo "<td><a href='mail.php?mode=view&up=$up&sort=$sort&filter=$filter&keyword=$keyword&mode=$mode&tree_mode=$tree_mode&perpage=$perpage&page=$page_p'>$previous</a>&nbsp;&nbsp;</td>";}
  if ($row[0] > $page_n*$perpage) {
    echo "<td colspan=2><a href='mail.php?mode=view&up=$up&sort=$sort&filter=$filter&keyword=$keyword&mode=$mode&tree_mode=$tree_mode&perpage=$perpage&page=$page_n$sid'>$next</a></td>\n";
  }
  if ($row[0] > $perpage) { echo "</tr>\n"; }

  // new table in navigation bar: actions
  echo "<tr><td colspan=7><table border=0 cellspacing=0 cellpadding=2 bgcolor=$bgcolor2 rules=none><tr>";

  // link to send mails = create new mail
  if (check_role("mail") > 1) { 
    echo "<td><a href='mail.php?mode=send_form&form=email$sid'>$mail_text29</a> | </td>\n";    
  }
  
  // view maillist on server  
  echo "<td><a href='mail.php?mode=view&action=fetch_new_mail&sort=$sort&up=$up&view_only=1$sid'>$mail_text51</a> ...</td>\n";

  // fetch mails
  echo "<td><a href='mail.php?mode=view&action=fetch_new_mail&sort=$sort&up=$up$sid'>$mail_text28</a> ...";
  echo "<a href='mail.php?mode=view&action=fetch_new_mail&sort=$sort&up=$up&no_del=1$sid'>$mail_text38</a> | \n";
  // new directory
  // check role
  if (check_role("mail") > 1) { 
    echo "<td><a href='mail.php?mode=view&action=form&form=d$sid'>$directory $l_text19</a> | </td>\n";
  }
  
  // define links for accounts and rules = options
  echo "<td>&nbsp;<a href='mail.php?mode=view&action=options$sid'>$o_opt&nbsp;</td>\n";
  echo "</tr></table></td></tr></table><br>\n";
  echo "<table width=100% border=0 cellpadding=1 cellspacing=0><tr>";  // grosse Tabelle
  // default sorting and direction
  if (!$sort) { $sort = "typ,date_sent"; $up = 1; }
  // direction
  $up2 = $up;
  if (!$up) {
    $direction = "ASC";
    $up = 1;
  }
  else {
    $direction="DESC";
    $up = 0;
  }  // sort up & down
  $e1="<td><b><a href='mail.php?mode=view&filter=$filter&keyword=$keyword&sort=";
  $e2="&up=$up&page=$page&perpage=$perpage$sid'>";
  $e3="</a></b></td>\n";
  echo $e1.'subject'.$e2.$mail_text1.$e3;
  echo $e1.'sender'.$e2.$mail_text22.$e3;
  // reply & forward buttons - only with role
  if (check_role("mail") > 1) {
    echo "<td>&nbsp;</td>\n"; 
  }
  echo $e1.'date_received'.$e2.$datei_text6.$e3;
  // same with the delete button
  if (check_role('mail') > 1) {  
    echo '<td>&nbsp;</td>'; // delete button
  }                                                                                                             
  echo "<td><b>$mail_text23</b></td>\n";      // attachment
  echo $e1.'kat'.$e2.$datei_text5.$e3;   // category
  if ($keyword) echo "<td><b>$datei_text8</b></td>"; // if keyword: additional display of the path
  echo "</tr>";
  $total_size = 0;

  // begin form for checkboxes to delete mails
  echo "<form action='mail.php' method=post>\n";
  echo "<input type='hidden' name='mode' value='view'>\n";
  echo "<input type=hidden name='action' value='delete'>\n";
  if(SID) echo "<input type=hidden name=PHPSESSID value='$PHPSESSID'>\n";

  // **********
  // real query
  $result = db_query("select ID  
                        from ".DB_PREFIX."mail_client 
                       where $where and 
                             von = '$user_ID' 
                    order by $sort $direction") or db_die();
  $i = 0;
  while ($row = db_fetch_row($result)) {
    $liste[$i] = $row[0];
    $i++;
  }
  //find maximum nuber
  if (($page+1)*$perpage > count($liste)) { $max = count($liste); }
  else { $max = ($page+1)*$perpage; }
  for ($i=($page*$perpage); $i < $max; $i++) {
    $ID = $liste[$i];
    $result = db_query("select ID,von,subject,body,sender,recipient,cc,kat,remark,date_received,touched,typ,
                               parent,date_sent,header,replyto,acc,body_html 
                          from ".DB_PREFIX."mail_client 
                         where ID = '$ID'") or db_die();
    $row = db_fetch_row($result);

    // call maillist
    include('./mail_list.php');

    // directory? if open, look for records below this level
    if ($row[11] == "d" and !$keyword and ($arrdir[$ID] or $tree_mode == "open")) { sub($row[0]); }
  }

  // show number of all mails and unread mails
  // fetch total number of mails
  $result2 = db_query("select count(ID) 
                         from ".DB_PREFIX."mail_client 
                        where typ <> 'd' and 
                              von = '$user_ID'") or db_die();
  $row2 = db_fetch_row($result2);
  $result3 = db_query("select count(ID) 
                         from ".DB_PREFIX."mail_client 
                        where typ <> 'd' and 
                              touched <> '1' and 
                              von = '$user_ID'") or db_die();
  $row3 = db_fetch_row($result3);
  echo "<tr><td colspan=6>$row2[0] $items2, $row3[0] $mail_text50<br>";
  echo "<tr><td colspan=3>";
  // submit button to delete mails
  if (check_role("mail") > 1) { 
    echo "<br><input type=submit value='$mail_text10'>&nbsp; | \n";
  }  
  // link to select all mails
  echo "&nbsp;<a href='mail.php?sel_all=1&filter=$filter&keyword=$keyword&sort=$sort&up=$up&page=$page&perpage=$perpage$sid'>$select_all</a>";
  echo "</td></tr></form>\n";
  echo "</table>\n";
}

function sub($ID) {
  global $PHPSESSID, $sid, $level, $user_access, $where, $projekte,
         $user_kurz, $admin_text7, $confirm, $datei_text18, $arrdir, $filter, $keyword, $sort, $direction,
         $up, $up2, $page, $perpage, $file_ID, $delete_it, $total_size, $tree_mode, $datei_text13,
         $mail_text25, $mail_text26, $img_path, $sel_all;

  $result = db_query("select ID,von,subject,body,sender,recipient,cc,kat,remark,date_received,touched,typ,
                             parent,date_sent,header,replyto,acc,body_html  
                        from ".DB_PREFIX."mail_client 
                       where parent = '$ID' 
                    order by $sort 
                             $direction") or db_die();
  while ($row = db_fetch_row($result)) {
    $ID = $row[0];
    $level++;
    include('./mail_list.php');
    if ($row[11] == "d" and ($arrdir[$ID] or $tree_mode == "open")) { sub($ID); }
    $level--;
  }
}

function del($delete_ID) {

  $result = db_query("select ID, von, typ 
                        from ".DB_PREFIX."mail_client 
                       where parent = '$delete_ID'") or db_die();
  while ($row = db_fetch_row($result)) {
    // delete attachments if it's not a directory
    if ($row[2] <> "d") {
      // select files
      $result2 = db_query("select tempname 
                             from ".DB_PREFIX."mail_attach 
                            where parent = '$delete_ID'") or db_die();
      while ($row2 = db_fetch_row($result2)) {
        $path = "attach/$row2[0]";
        unlink($path);
      }
      // delete records
      $result2 = db_query("delete from ".DB_PREFIX."mail_attach 
                            where parent = '$delete_ID'") or db_die();
    }
    // directory? -> free rules
    else { $result2 = db_query("update ".DB_PREFIX."mail_rules 
                                   set parent = '' 
                                 where parent = '$delete_ID'") or db_die(); }

    // for all types: delete record itself
    $result2 = db_query("delete from ".DB_PREFIX."mail_client 
                          where ID = '$row[0]'") or db_die();
    if ($row[2] == "d") del($row[0]); // look for mails etc. in the subdirectory
  }
}

function copy_attachments($ID) {
  global $user_ID, $row, $dbTSnull, $path_pre, $dbIDnull;

  // 1. fetch the ID of the new record
  $result2 = db_query("select ID 
                         from ".DB_PREFIX."mail_client 
                        where date_received = '$dbTSnull' and 
                              von = '$user_ID' and 
                              subject = '$row[2]'") or db_die(); // fetch missing values from old record
  $row2 = db_fetch_row($result2);
  // now fetch all attachments from the previous mail
  $result3 = db_query("select filename, filesize, tempname 
                         from ".DB_PREFIX."mail_attach 
                        where parent = '$ID'") or db_die();
  while ($row3 = db_fetch_row($result3)) {
    // create a new random att name
    $att_tempname = "";
    srand((double)microtime()*1000000);
    $char = "123456789abcdefghijkmnopqrstuvwxyzABCDEFGHIJKLMANOPQRSTUVWXYZ";
    while (strlen($att_tempname) < 12) { $att_tempname .= substr($char,(rand()%(strlen($char))),1);}
    // add extension to random name
    $att_tempname .= substr($row3[0],-4,4);
    // copy file
    copy($path_pre."attach/".$row3[2],$path_pre."attach/".$att_tempname);
    // write record to db
    $result4 = db_query("insert into ".DB_PREFIX."mail_attach 
                                (   ID,     parent,   filename,        tempname,  filesize )
                         values ($dbIDnull,'$row2[0]','$row3[0]','$att_tempname','$row3[1]')") or db_die();
  }
}

?>
