<?php
// todo_data.php - PHProjekt Version 4.1
// copyright    2000-2003 Albrecht Guenther  ag@phprojekt.com
// www.phprojekt.com
// Author: Albrecht Guenther
 
// check whether the lib has been included - authentication!
if (!defined("lib_included")) { die("Please use index.php!"); }

// check role 
if (check_role("todo") < 2) { die("You are not allowed to do this!"); }

// fetch permission routines
include_once("$lib_path/permission.inc.php"); 
$include_path3 = $path_pre."lib/access.inc.php";
include_once $include_path3; 
$access = assign_acc($acc, 'todo'); 

switch (true) { 
  
  case ($cancel):
    break;
    
  // undertake todo
  case ($undertake==1):
    //check whether this todo is still free ..
    $result = db_query("select ext 
                          from ".DB_PREFIX."todo 
                         where ID = '$ID'") or db_die();
    $row = db_fetch_row($result);  
    if ($row[0] <> '') {
      // assign this todo to the current user                           
      $result = db_query("update ".DB_PREFIX."todo 
                             set ext = '$user_ID',
                                 status = '3'
                           where ID = '$ID'") or db_die();        
    }
    break;       
     
  case ($delete <> ""):
    $result = db_query("select von, ext 
                          from ".DB_PREFIX."todo 
                         where ID = '$ID'") or db_die();
    $row = db_fetch_row($result);  
    // 1. case: user is recipient. then he is able to delete this todo if
    // he has chief status or if it is an old todo from 3.3 without any sender.
    if ($row[1] == $user_ID and (!$row[0] or ereg("c",$user_access))) {}       
    // 2. check permission if the user is the author of this todo    
    elseif ($row[0] > 0 ) { check_permission("todo","von",$ID); }  
    // 3. deny deletion if the suer is not the recipient.         
    elseif ($row[1] <> $user_ID) { die("You are not alled to do this"); }
    
    // delete request
    $result = db_query("delete from ".DB_PREFIX."todo 
                           where ID = '$ID'") or db_die();      
    break;
   
  case ($step == "create"): 
    // Status - if it an own todo, put it to accepted, otherwise to open
    if ($to_user == $user_ID) $status = 3;
    // at the moment of creation the progress must be 0
    $progress = 0; 
    
    // assign access
    if ($acc_write <> '') { $acc_write = 'w'; }

    // create record in db  
    $result = db_query("insert into ".DB_PREFIX."todo 
                               (   ID,      von,      remark,   ext,       note,   deadline,    datum,     status,   priority,   progress,   project,   contact,sync1, comment1,   anfang,        gruppe,  acc,   acc_write )     
                        values ($dbIDnull,'$user_ID','$title','$to_user','$note','$deadline','$dbTSnull','$status','$priority','$progress','$project','$contact','0','$comment1','$anfang','$user_group','$access','$acc_write')") or db_die();
    // notify recipient about the new todo                                           
    if ($notify_recipient <> '' and $to_user > 0) { 
      // include the library from lib
      include_once("$lib_path/email_notification.inc.php");
      $recipient = array(slookup('users','kurz','ID',$to_user));
      email_notification($todo_text10, 
                         serialize($recipient), 
                         $todo_text10.": ".$title."\n".$forum_text8.": ".slookup('users','nachname,vorname','ID',$userID)."\n".$note); 
    }
    break; 
    
  case ($step == "update_progress"):
    // check whether this user is allowed to update the prgress
    $result = db_query("select ext 
                          from ".DB_PREFIX."todo 
                         where ID = '$ID'") or db_die();
    $row = db_fetch_row($result);         
    if ($row[0] <> $user_ID) { die("You are not allowed to do this!"); }
    // otherwise update the progress :-)      
    $result = db_query("update ".DB_PREFIX."todo 
                           set progress = '$progress' 
                         where ID = '$ID'") or db_die();        
    break;           
  
  case ($ID > 0):
    // check permission
    $result = db_query("select von, ext, status
                          from ".DB_PREFIX."todo 
                         where ID = '$ID'") or db_die();
    $row = db_fetch_row($result);                 
    // 1. update of the whole record - only the author      
    if ($row[0] == $user_ID)  {  
      // workaround if $status is not set
      if (!$status) { $status = $row[2]; }   
      // an owner of a todo can stop the todo without deleting it:
      if ($todo_done <> "") { $status = 5; }  
      
      $accessstring = "acc = '$access',";
      if ($acc_write <> '') $accesswritestring = "acc_write = 'w',";
      
      // update record in db
      $result = db_query("update ".DB_PREFIX."todo 
                             set $accessstring
                                 $accesswritestring
                                 ext = '$to_user',
                                 remark = '$title',
                                 note = '$note',
                                 deadline = '$deadline',
                                 priority = '$priority',
                                 project = '$project',
                                 contact = '$contact',
                                 sync1 = '1',                                                                          
                                 status = '$status',
                                 comment1 = '$comment1',
                                 anfang = '$anfang'
                           where ID = '$ID'") or db_die(); 
    }   
    // 2. case - only update of the status
    if ($row[1] == $user_ID) {
      if ($status <> '' or $todo_done <> '') {            
        // security check: make sure the assigned user hasn't hacked the form  
        if ($status < 3) $status = $row[2]; 
        // if the user has clicked 'done', set the status to value 5
        if ($todo_done <> "") { $status = 5; $progress = 100; }
        $result = db_query("update ".DB_PREFIX."todo 
                               set status = '$status' 
                             where ID = '$ID'") or db_die(); 
      }
      if ($progress <> "") { 
        $result = db_query("update ".DB_PREFIX."todo 
                               set progress= '$progress' 
                             where ID = '$ID'") or db_die(); 
      }               
      // update comment and flag for sync1 in any case 
      $result = db_query("update ".DB_PREFIX."todo 
                             set comment2 = '$comment2', 
                                 sync1 = '1' 
                           where ID = '$ID'") or db_die();                         
    }
    break;
}  


// show the todo list :-)
$status = 0;
include_once("./todo_view.php");

?>
</body>
</html>
